/* Specification:
Barbara Williams
Created/Revised on October 3, 2010
Ch 15 Lab 5
This lab writes a program which consists of a racing car game. 
The RacingData class is used to represent the outcome of a 
certain race. In this lab I created this class with its appropriate 
attributes and functions. I then overloaded the + operator to work 
with this class. Finally, I created a small main() program to test my work.*/

/*RacingData.h the specification file for the class RacingData contains 
eight public member functions and four private data member variables.*/

//Required by cout command
#include <iostream>

//Required by string data type
#include <string>

//Default namespace defining library functions (e.g. cout, endl)
using namespace std;

/******************************
* RacingData class definition
*******************************/
class RacingData
{
	public:
		//Default constructor
		RacingData();
		
		/*An overloaded constructor that takes four parameters to set the
		name, score, minutes, and seconds. Function is to set the member 
		variables playerName, xScore, min, and sec according to the parameters.
		Postconditions: name = playerName; score = xScore; minute = min; and 
		second = sec; values are used to initialize the member variables.*/
		RacingData(string, int, int, int);
				
		//operator+ overload function
		RacingData operator+(RacingData &) const;
		
		/*A mutator method called setDriverName that takes one reference parameter and
		returns void. Function is to set the name. The driverName data is set according
		to the parameter. Postconditions: drName */
		void setDriverName(string);
		
		/*A mutator method called setRacingData that takes three reference parameters and
		returns void. Function is set the score, minute, and second. The racing data is 
		set according to the parameter. Postconditions: xScore, min, sec. The function 
		checks whether the value of sec(seconds) is valid. If value is invalid, the default 
		value is assigned. */
		void setRacingData(int, int, int);
		
		/* An accessor method called getDriverName that takes no parameters and returns
		a string. Function is to return the name. Postconditions: drName */
		string getDriverName();
		
		/*An accessor method called getRacingData that takes three parameters and
		returns void. Function is to return the racing data (score, minute, and second).
		Postconditions: xScore, min, sec */
		int getRacingData(int&, int&, int&) const;
		
		/*A constant method called printRacingData that takes no parameters, returns
		void and outputs the racing (name, score, min, sec). Function is to print the
		racing data. Postconditions: The name is printed in the form of a string. The 
		score, min, and sec are printed in the form of an integer.*/
		void printRacingData() const;
		
	private:
		//Data member (variable) to store the name.
		string name;
			
		//Data member (variable) to store the score.
		int score;
			
		//Data member (variable) to store the minute.
		int minute;
			
		//Data member (variable) to store the second.
		int second;
};


		