/* Specification:
Barbara Williams
Created/Revised on October 3, 2010
Ch 15 Lab 5
This lab writes a program which consists of a racing car game. 
The RacingData class is used to represent the outcome of a 
certain race. In this lab I created this class with its appropriate 
attributes and functions. I then overloaded the + operator to work 
with this class. Finally, I created a small main() program to test my work.*/

//Required by cout command
#include <iostream>	

//Required by string data type
#include <string>

//RacingData header file - Required by class
#include "RacingData.h"

//Default namespace defining library functions (e.g. cout, endl)
using namespace std;

int main()
{
	//declare variables for names, minutes, seconds, scores
	RacingData dpName;
	RacingData jgName;
	int dpMinute = 0;
	int jgMinute = 0;
	int dpSecond = 0;
	int jgSecond = 0;
	int dpScore = 0;
	int jgScore = 0;
	
	//declare objects using the overloaded constructors
	RacingData dpTotal;
	RacingData jgTotal;
	
	//creating six objects
	RacingData dpLap1;
	RacingData dpLap2;
	RacingData dpLap3;
	RacingData jgLap1;
	RacingData jgLap2;
	RacingData jgLap3;
	
	//setting object values using setRacingData
	jgLap1.setRacingData(155,10,10);
	jgLap2.setRacingData(127,11,15);
	jgLap3.setRacingData(34,12,35);
	dpLap1.setRacingData(185,11,20);
	dpLap2.setRacingData(103,11,30);
	dpLap3.setRacingData(73,12,40);
	
	//setting object values using setDriverName
	dpName.setDriverName("Danika Patrick");
	jgName.setDriverName("Jeff Gordon");
	
	//printout race stats for Danika Patrick
	cout << "Lap 1: " << dpName.getDriverName();
	dpLap1.printRacingData();
	cout << "Lap 2: " << dpName.getDriverName();
	dpLap2.printRacingData();
	cout << "Lap 3: : << dpName.getDriverName();
	dpLap3.printRacingData();
	cout << endl;
	
	//printout race stats for Jeff Gordon
	cout << "Lap 1: " << jgName.getDriverName();
	jgLap1.printRacingData();
	cout << "Lap 2: " << jgName.getDriverName();
	jgLap2.printRacingData();
	cout << "Lap 3: : << jgName.getDriverName();
	jgLap3.printRacingData();
	cout << endl;
	
	//use overloaded "+" operator to add scores and times for Danika's 3 races
	dpTotal = dpLap1 + dpLap2 + dpLap3;
	dpTotal.getRacingData(dpScore, dpMinute, dpSecond);
	
	//print totals
	cout << dpName.getDriverName() << " has a total score of " << dpScore << " in "'
	cout << dpMinute << " minutes and " << dpSecond << " seconds.";
	cout << endl;
	
	//use overloaded "+" operator to add scores and times for Jeff's 3 races
	jgTotal = jgLap1 + jgLap2 + jgLap3;
	d=jgTotal.getRacingData(jgScore, jgMinute, jgSecond);
	
	//print totals
	cout << jgName.getDriverName() << " has a total score of " << jgScore << " in "'
	cout << jgMinute << " minutes and " << jgSecond << " seconds.";
	cout << endl;
	
	/*Determine and print the racer with the highest total score output - high score
	compares total scores and outputs high score */
	if (dpScore > jgScore)
	{
		cout << "The driver with the highest score was: " << dpName.getDriverName();
		dpTotal.printRacingData();
	}
	
	else
	{
		cout << "The driver with the highest score was: " << jgName.getDriverName();
		jgTotal.printRacingData();
	}
	
	/* Determine and print the racer with the lowest total time - output low time compares
	total minute and total second, then outputs low time */
	if ((dpMinute && dpSecond) < (jgMinute && jgSecond))
	{
		cout << "The driver with the lowest time was: " << dpName.getDriverName();
		dpTotal.printRacingData();
	}
	
	else
	{
		cout << "The driver with the lowest time was: " << jgName.getDriverName();
		jgTotal.printRacingData();
	}
	
	//output average score and time for Danika Patrick
	cout << dpName.getDriverName() << " has an average score of " << dpScore /3 << " in ";
	cout << dpMinute /3 << " minutes and " << dpSecond /3 << " seconds." ;
	cout << endl;
	
	//output average score and time for Jeff Gordon
	cout << jgName.getDriverName() << " has an average score of " << jgScore /3 << " in ";
	cout << jgMinute /3 << " minutes and " << jgSecond /3 << " seconds." ;
	cout << endl << endl;
	
	return 0;
}
	