/* Specification:
Barbara Williams
Created/Revised on October 3, 2010
Ch 15 Lab 5
This lab writes a program which consists of a racing car game. 
The RacingData class is used to represent the outcome of a 
certain race. In this lab I created this class with its appropriate 
attributes and functions. I then overloaded the + operator to work 
with this class. Finally, I created a small main() program to test my work.*/

/*RacingDataImp.cpp, the implementation file. The user program that
uses RacingData class */

//RacingData header file - Required by class
#include "RacingData.h"

//Implementation of the default constructor
RacingData::RacingData()
{
	string name = " ";
	int score = 0;
	int minute = 0;
	int second = 0;

}	//end default constructor

//operator+ overload function
RacingData RacingData::operator + (RacingData &rd) const
{
	RacingData result;
	
	//add up all data elements
	result.score = score + rd.score;
	result.minute = minute + rd.minute;
	result.second = second + rd.second;
	
	//reduce seconds to below 60
	if (result.second >= 60)
	{
		result.minute += result.second / 60;
		result.second += result.second % 60;
	}
	
	return result;
	
}	//end operator+ overload function

//implementation of the constructor with parameters
RacingData::RacingData(string driverName, int xScore, int min, int sec)
{
	//set values
	name = driverName;
	score = xScore;
	minute = min;
	second = sec;
	
}	//end constructor with parameters

/* Accessor method called getDriverName that takes one parameter and returns a
string. Function is to return the name.*/
string RacingData::getDriverName()
{
	return name;

}	//end getDriverName

/*Accessor method called getRacingData that takes three parameters and returns
void. Function is to return the score, minute, and second.*/
int RacingData::getRacingData(int &xScore, int &min, int &sec) const
{
	//sets values
	xScore = score;
	min = minute;
	sec = second;
	
	return score, minute, second;
	
}	//end getRacingData

/*A mutator method called setDriverName that takes one reference parameter and
returns a string. Function is to set the name.*/
void RacingData::setDriverName(string drName)
{
	name = drName;

}	//end setDriverName

/*A mutator method called setRacingData that takes three reference parameters and 
returns void. Function is to set the name, score, minute, and second.*/
void RacingData::setRacingData(int xScore, int min, int sec)
{
	//sets values
	score = xScore;
	minute = min;
	second = sec;
	
	//validates minutes between 0 and 60
	if (0 <= min && min < 60)
		minute = min;
	else
		minute = 0;

}	//end setRacingData

/*A constant method called printRacingData that takes no parameters, returns void and
outputs the name, score, minute, and second.*/
void RacingData::printRacingData() const
{
	cout << " scored a total of " << score << " points in a total of " << minute;
	cout << " minutes and " << second << " seconds." << endl;
	
}	//end printRacingData